
/*  A Bison parser, made from mvcl.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse Mvclparse
#define yylex Mvcllex
#define yyerror Mvclerror
#define yylval Mvcllval
#define yychar Mvclchar
#define yydebug Mvcldebug
#define yynerrs Mvclnerrs
#define	PROC	258
#define	END	259
#define	IF	260
#define	THEN	261
#define	ELSE	262
#define	ENDIF	263
#define	FOR	264
#define	TO	265
#define	DOWNTO	266
#define	ENDFOR	267
#define	OPEN	268
#define	CLOSE	269
#define	READ	270
#define	SET	271
#define	STATUS	272
#define	WAIT	273
#define	TIMEOUT	274
#define	EXTEND	275
#define	RETRACT	276
#define	WAITFOR	277
#define	PUMPON	278
#define	PUMPOFF	279
#define	EXIT	280
#define	PERROR	281
#define	PRINT	282
#define	PRETURN	283
#define	V	284
#define	P	285
#define	HCIG	286
#define	CCIG	287
#define	BT	288
#define	TC	289
#define	NZ	290
#define	PT	291
#define	MFC	292
#define	NAME	293
#define	SEMICOLON	294
#define	COMPARISON	295
#define	ASSIGNMENT	296
#define	QSTRING	297
#define	IDENTIFIER	298
#define	INTARG	299
#define	REALARG	300
#define	SHELL_START	301
#define	STREAM_START	302
#define	STRING_START	303
#define	INTEGER	304
#define	REAL	305
#define	UNKNOWN	306
#define	HELP	307
#define	UMINUS	308

#line 1 "mvcl.y"

/*                         MICRION SOFTWARE DEPT.
 *          Copyright (c) 1994 by Micrion Corp. All rights reserved.
 *
 * FILE NAME    : mvcl.y
 * AUTHOR       : R. Mello
 * DATE WRITTEN : 12/12/94
 * VERSION      : 1.00
 * USAGE        : grammar processor for the mvcl programming language
 * 
 *  This file contains a yacc grammar for the micrion ( M ) vacuum ( V )
 * command ( C ) language ( L ).
 */
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <mvcl_int.h>

/* uncomment the following line to compile the main() in for the Mvcl
 * shell interpreter.
 */
/* #define MVCL_STAND_ALONE */

/* uncomment the following line to test unusual mvcl functions -- this is only
 * available if MVCL_STAND_ALONE is defined.
 */
/* #define TESTING_MVCL */

/* file equates. */
#define YYDEBUG 1

/* external reference to error func */
extern void  yyerror( char *s );

/* local globals */
static MvclProgramList *prog = (MvclProgramList *)NULL;
static MvclProgramNode *Node;
static char            *tmp;
static int             ret;
static MvclPrintItem   *plist = (MvclPrintItem *)NULL;

#line 43 "mvcl.y"
typedef union
  {
   double   real;
   int	    integer;
   char	    *string;
  } YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		147
#define	YYFLAG		-32768
#define	YYNTBASE	59

#define YYTRANSLATE(x) ((unsigned)(x) <= 308 ? yytranslate[x] : 104)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,    55,    53,    58,    54,     2,    56,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    57
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     6,     9,    13,    17,    20,    24,    26,    28,
    30,    32,    34,    36,    42,    48,    50,    52,    57,    64,
    66,    68,    72,    74,    79,    85,    91,    93,    95,    97,
    99,   101,   104,   107,   109,   110,   112,   115,   117,   120,
   122,   124,   126,   128,   132,   136,   138,   140,   142,   144,
   146,   148,   150,   152,   154,   156,   158,   160,   162,   164,
   168,   172,   175,   180,   184,   188,   192,   196,   199,   205,
   208,   210,   214,   216,   218,   220,   222,   224,   226,   228,
   230,   232,   234,   236,   238,   240,   241
};

static const short yyrhs[] = {    46,
    81,     0,    47,    60,     0,    48,    79,     0,    61,    62,
    78,     0,     3,    42,    39,     0,    63,    39,     0,    63,
    39,    62,     0,    64,     0,    65,     0,    88,     0,    66,
     0,    72,     0,    77,     0,    43,    41,    17,   102,   103,
     0,    43,    41,    15,   102,   103,     0,    67,     0,    68,
     0,     5,    71,    62,    70,     0,     5,    71,    62,    69,
    62,    70,     0,     7,     0,     8,     0,    76,    40,    76,
     0,    73,     0,     9,    74,    62,    75,     0,    43,    41,
    76,    10,    76,     0,    43,    41,    76,    11,    76,     0,
    12,     0,    43,     0,    50,     0,    49,     0,    42,     0,
    28,    49,     0,     4,    39,     0,    80,     0,     0,    83,
     0,    82,    87,     0,    83,     0,    83,    82,     0,    84,
     0,    85,     0,    86,     0,    88,     0,    17,   102,   103,
     0,    15,   102,   103,     0,    52,     0,     4,     0,    89,
     0,    90,     0,    91,     0,    92,     0,    93,     0,    94,
     0,    95,     0,    96,     0,    97,     0,    98,     0,    99,
     0,     1,     0,    13,    29,   103,     0,    14,    29,   103,
     0,    19,    50,     0,    16,   102,   103,    50,     0,    23,
    30,   103,     0,    24,    30,   103,     0,    20,    35,   103,
     0,    21,    35,   103,     0,    18,    50,     0,    22,   102,
   103,    40,    50,     0,    27,   100,     0,   101,     0,   101,
    58,   100,     0,    42,     0,    43,     0,    50,     0,    49,
     0,    29,     0,    30,     0,    31,     0,    32,     0,    33,
     0,    34,     0,    35,     0,    36,     0,    37,     0,     0,
    49,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    82,    83,    84,    89,    92,    95,    96,    99,   100,   101,
   102,   103,   104,   107,   113,   119,   120,   123,   126,   130,
   137,   144,   151,   154,   157,   162,   169,   176,   177,   178,
   179,   185,   190,   195,   198,   199,   204,   207,   208,   211,
   212,   213,   214,   217,   223,   229,   232,   238,   239,   240,
   241,   242,   243,   244,   245,   246,   247,   248,   249,   255,
   261,   268,   274,   280,   286,   292,   298,   304,   310,   316,
   327,   328,   331,   334,   337,   341,   348,   349,   350,   351,
   352,   353,   354,   355,   356,   359,   360
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PROC","END",
"IF","THEN","ELSE","ENDIF","FOR","TO","DOWNTO","ENDFOR","OPEN","CLOSE","READ",
"SET","STATUS","WAIT","TIMEOUT","EXTEND","RETRACT","WAITFOR","PUMPON","PUMPOFF",
"EXIT","PERROR","PRINT","PRETURN","V","P","HCIG","CCIG","BT","TC","NZ","PT",
"MFC","NAME","SEMICOLON","COMPARISON","ASSIGNMENT","QSTRING","IDENTIFIER","INTARG",
"REALARG","SHELL_START","STREAM_START","STRING_START","INTEGER","REAL","UNKNOWN",
"HELP","'+'","'-'","'*'","'/'","UMINUS","','","combined","mvcl_stream","proc_statement",
"mvcl_statements","mvcl_stream_statements","status_statement","read_statement",
"cond_statements","if_statement","if_else_statement","else_statement","endif_statement",
"if_test","loop_statements","for_statement","for_args","endfor_statement","expr",
"return_statement","end_program","mvcl_string","mvcl_string_statements","mvcl_shell",
"mvcl_shell_statements","mvcl_shell_commands","status_command","read_command",
"help_command","end_shell","mvcl_statement","open_statement","close_statement",
"timeout_statement","set_statement","pumpon_statement","pumpoff_statement","extend_statement",
"retract_statement","wait_statement","waitfor_statement","print_statement","print_list",
"print_item","dev_class","dev_id", NULL
};
#endif

static const short yyr1[] = {     0,
    59,    59,    59,    60,    61,    62,    62,    63,    63,    63,
    63,    63,    63,    64,    65,    66,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    74,    75,    76,    76,    76,
    76,    77,    78,    79,    80,    80,    81,    82,    82,    83,
    83,    83,    83,    84,    85,    86,    87,    88,    88,    88,
    88,    88,    88,    88,    88,    88,    88,    88,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   100,   101,   101,   101,   101,   102,   102,   102,   102,
   102,   102,   102,   102,   102,   103,   103
};

static const short yyr2[] = {     0,
     2,     2,     2,     3,     3,     2,     3,     1,     1,     1,
     1,     1,     1,     5,     5,     1,     1,     4,     6,     1,
     1,     3,     1,     4,     5,     5,     1,     1,     1,     1,
     1,     2,     2,     1,     0,     1,     2,     1,     2,     1,
     1,     1,     1,     3,     3,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
     3,     2,     4,     3,     3,     3,     3,     2,     5,     2,
     1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     0,     1
};

static const short yydefact[] = {     0,
     0,     0,     0,    59,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    46,     1,     0,
     0,    40,    41,    42,    43,    48,    49,    50,    51,    52,
    53,    54,    55,    56,    57,    58,     0,     2,     0,     3,
    34,    36,    86,    86,    77,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    86,    86,    68,    62,    86,    86,
    86,    86,    86,    73,    74,    76,    75,    70,    71,    47,
    37,    39,     0,     0,     0,     0,     0,     0,     0,     8,
     9,    11,    16,    17,    12,    23,    13,    10,    87,    60,
    61,    45,     0,    44,    66,    67,     0,    64,    65,     0,
     5,    31,    28,    30,    29,     0,     0,     0,     0,    32,
     0,     0,     4,     0,    63,     0,    72,     0,     0,     0,
     0,     0,     0,    33,     7,    69,    20,    21,     0,    18,
    22,     0,    27,    24,    86,    86,     0,     0,     0,    15,
    14,    19,    25,    26,     0,     0,     0
};

static const short yydefgoto[] = {   145,
    38,    39,    78,    79,    80,    81,    82,    83,    84,   129,
   130,   106,    85,    86,   109,   134,   107,    87,   113,    40,
    41,    19,    20,    21,    22,    23,    24,    71,    88,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    68,    69,    54,    90
};

static const short yypact[] = {   -43,
    57,     8,     9,-32768,     6,    10,    66,    66,    66,    -9,
    -7,     7,    30,    66,    39,    53,    62,-32768,-32768,    83,
    33,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    46,-32768,   140,-32768,
-32768,-32768,    40,    40,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,    40,    40,    40,-32768,-32768,    40,    40,
    40,    40,    40,-32768,-32768,-32768,-32768,-32768,    32,-32768,
-32768,-32768,    52,   101,    49,    58,    67,   102,    71,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    68,-32768,-32768,-32768,    82,-32768,-32768,    62,
-32768,-32768,-32768,-32768,-32768,   140,    87,    88,   140,-32768,
    23,    84,-32768,   112,-32768,    92,-32768,     0,   101,   101,
   125,    66,    66,-32768,-32768,-32768,-32768,-32768,   140,-32768,
-32768,     5,-32768,-32768,    40,    40,   130,   101,   101,-32768,
-32768,-32768,-32768,-32768,   146,   147,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,   -47,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    11,-32768,-32768,-32768,-32768,-32768,   -75,-32768,-32768,-32768,
-32768,-32768,   131,   154,-32768,-32768,-32768,-32768,    65,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
    69,-32768,    -8,   -42
};


#define	YYLAST		183


static const short yytable[] = {    55,
    56,    91,     1,     2,     3,    61,   127,   128,   -35,     4,
    37,    92,    93,    94,   138,   139,    95,    96,    97,    98,
    99,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,     4,    43,    17,   -38,   122,    44,   123,
    57,    59,    58,   131,   132,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,     4,   118,    17,
    18,   121,   143,   144,    60,    25,   125,    25,    62,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,   137,    63,    17,    18,    25,    70,    73,    89,   100,
   101,   108,   140,   141,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    64,    65,   112,   110,   111,    18,   114,
    66,    67,     4,   135,   136,    -6,    74,   115,    -6,    -6,
    75,   116,   124,    -6,     5,     6,   119,     8,   120,    10,
    11,    12,    13,    14,    15,    16,   133,   128,    17,    76,
     4,   126,   102,   103,    74,   146,   147,   142,    75,   104,
   105,    72,     5,     6,    77,     8,    42,    10,    11,    12,
    13,    14,    15,    16,     0,     0,    17,    76,   117,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    77
};

static const short yycheck[] = {     8,
     9,    44,    46,    47,    48,    14,     7,     8,     0,     1,
     3,    54,    55,    56,    10,    11,    59,    60,    61,    62,
    63,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,     1,    29,    27,     4,    15,    29,    17,
    50,    35,    50,   119,   120,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,     1,   106,    27,
    52,   109,   138,   139,    35,     1,   114,     3,    30,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,   129,    30,    27,    52,    21,     4,    42,    49,    58,
    39,    43,   135,   136,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    42,    43,     4,    49,    41,    52,    39,
    49,    50,     1,   122,   123,     4,     5,    50,     7,     8,
     9,    40,    39,    12,    13,    14,    40,    16,    41,    18,
    19,    20,    21,    22,    23,    24,    12,     8,    27,    28,
     1,    50,    42,    43,     5,     0,     0,   137,     9,    49,
    50,    21,    13,    14,    43,    16,     3,    18,    19,    20,
    21,    22,    23,    24,    -1,    -1,    27,    28,   100,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    43
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 14:
#line 108 "mvcl.y"
{ if( BuildMvclStatusNode( prog, yyvsp[-4].string, yyvsp[-1].integer, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 15:
#line 114 "mvcl.y"
{ if( BuildMvclReadNode( prog, yyvsp[-4].string, yyvsp[-1].integer, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 20:
#line 131 "mvcl.y"
{
                        if( BuildMvclElseNode( prog ) )
                          YYABORT;
                       ;
    break;}
case 21:
#line 138 "mvcl.y"
{
                        if( BuildMvclEndifNode( prog ) )
                          YYABORT;
		       ;
    break;}
case 22:
#line 145 "mvcl.y"
{
                        if( BuildMvclIfNode( prog, yyvsp[-2].string, yyvsp[-1].integer, yyvsp[0].string ) )
			  YYABORT;
                       ;
    break;}
case 25:
#line 158 "mvcl.y"
{
                        if( BuildMvclForNode( prog, yyvsp[-4].string, yyvsp[-2].string, MVCL_FOR_TO, yyvsp[0].string ) )
                          YYABORT;
		       ;
    break;}
case 26:
#line 163 "mvcl.y"
{
                        if( BuildMvclForNode(prog, yyvsp[-4].string, yyvsp[-2].string, MVCL_FOR_DOWNTO,yyvsp[0].string))
                          YYABORT;
		       ;
    break;}
case 27:
#line 170 "mvcl.y"
{
                        if( BuildMvclEndForNode( prog ) )
                          YYABORT;
		       ;
    break;}
case 28:
#line 176 "mvcl.y"
{ yyval.string = yyvsp[0].string;                               ;
    break;}
case 29:
#line 177 "mvcl.y"
{ yyval.string = MvclCreateRealSymbol( prog, yyvsp[0].real ); ;
    break;}
case 30:
#line 178 "mvcl.y"
{ yyval.string = MvclCreateIntSymbol( prog, yyvsp[0].integer );  ;
    break;}
case 31:
#line 180 "mvcl.y"
{ MvclParserError( "Incompatible Types\n" );
                         YYABORT;
                       ;
    break;}
case 32:
#line 186 "mvcl.y"
{
                        BuildMvclReturnNode( prog, yyvsp[0].integer );
                       ;
    break;}
case 44:
#line 218 "mvcl.y"
{ tmp = MvclGenerateVariable();
                          BuildMvclStatusNode( prog, tmp, yyvsp[-1].integer, yyvsp[0].integer );
			;
    break;}
case 45:
#line 224 "mvcl.y"
{ tmp = MvclGenerateVariable();
			  BuildMvclReadNode( prog, tmp, yyvsp[-1].integer, yyvsp[0].integer );
			;
    break;}
case 46:
#line 230 "mvcl.y"
{ MvclShellHelp();  ;
    break;}
case 47:
#line 233 "mvcl.y"
{ exit( 0 ); ;
    break;}
case 59:
#line 250 "mvcl.y"
{ if( MvclGetParserMode() == MVCL_STREAM )
                            YYABORT;
			;
    break;}
case 60:
#line 256 "mvcl.y"
{ if( BuildMvclOpenNode( prog, yyvsp[0].integer ) )
                            YYABORT;
			;
    break;}
case 61:
#line 262 "mvcl.y"
{ if( BuildMvclCloseNode( prog, yyvsp[0].integer ) )
			    YYABORT;
                        ;
    break;}
case 62:
#line 269 "mvcl.y"
{ if( BuildMvclTimeoutNode( prog, yyvsp[0].real ) )
			    YYABORT;
			;
    break;}
case 63:
#line 275 "mvcl.y"
{ if( BuildMvclSetNode( prog, yyvsp[-2].integer, yyvsp[-1].integer, yyvsp[0].real ) )
			    YYABORT;
 			;
    break;}
case 64:
#line 281 "mvcl.y"
{ if( BuildMvclPumpOnNode( prog, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 65:
#line 287 "mvcl.y"
{ if( BuildMvclPumpOffNode( prog, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 66:
#line 293 "mvcl.y"
{ if( BuildMvclExtendNode( prog, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 67:
#line 299 "mvcl.y"
{ if( BuildMvclRetractNode( prog, yyvsp[0].integer ) )
			    YYABORT;
			;
    break;}
case 68:
#line 305 "mvcl.y"
{ if( BuildMvclWaitNode( prog, yyvsp[0].real ) )
			    YYABORT;
			;
    break;}
case 69:
#line 311 "mvcl.y"
{ if( BuildMvclWaitForNode( prog, yyvsp[-3].integer, yyvsp[-2].integer, yyvsp[-1].integer, yyvsp[0].real ))
			    YYABORT;
			;
    break;}
case 70:
#line 317 "mvcl.y"
{ ret = BuildMvclPrintNode( prog, plist );

                          /* init for another list. */
                          plist = (MvclPrintItem *)NULL;
                    
                          if( ret )
                            YYABORT;
                        ;
    break;}
case 73:
#line 332 "mvcl.y"
{ MvclAddToPrintList( &plist, yyvsp[0].string, MVCL_PRINT_STR );
                        ;
    break;}
case 74:
#line 335 "mvcl.y"
{ MvclAddToPrintList( &plist, yyvsp[0].string, MVCL_PRINT_IDENT );
                        ;
    break;}
case 75:
#line 338 "mvcl.y"
{ tmp = MvclCreateRealSymbol( prog, yyvsp[0].real );
                         MvclAddToPrintList( &plist, tmp, MVCL_PRINT_REAL );
                        ;
    break;}
case 76:
#line 342 "mvcl.y"
{ tmp = MvclCreateIntSymbol( prog, yyvsp[0].integer );
                         MvclAddToPrintList( &plist, tmp, MVCL_PRINT_INT );
                        ;
    break;}
case 77:
#line 348 "mvcl.y"
{ yyval.integer = MVCL_VALVE_CLASS;	;
    break;}
case 78:
#line 349 "mvcl.y"
{ yyval.integer = MVCL_PUMP_CLASS;    	;
    break;}
case 79:
#line 350 "mvcl.y"
{ yyval.integer = MVCL_HCIG_CLASS;	;
    break;}
case 80:
#line 351 "mvcl.y"
{ yyval.integer = MVCL_CCIG_CLASS;	;
    break;}
case 81:
#line 352 "mvcl.y"
{ yyval.integer = MVCL_BT_CLASS;		;
    break;}
case 82:
#line 353 "mvcl.y"
{ yyval.integer = MVCL_TC_CLASS;		;
    break;}
case 83:
#line 354 "mvcl.y"
{ yyval.integer = MVCL_NZ_CLASS;		;
    break;}
case 84:
#line 355 "mvcl.y"
{ yyval.integer = MVCL_PT_CLASS;		;
    break;}
case 85:
#line 356 "mvcl.y"
{ yyval.integer = MVCL_MFC_CLASS;		;
    break;}
case 86:
#line 359 "mvcl.y"
{ yyval.integer = 0; 			;
    break;}
case 87:
#line 360 "mvcl.y"
{ yyval.integer = yyvsp[0].integer;			;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 362 "mvcl.y"

/***************************************************************************/
int  MvclSetParserProgramList(
   MvclProgramList  *new_list )

  {
   /* MvclSetParserProgramList() -- This function will allow an outside source
    *     to set the current program list pointer to a list of thier own
    *     creation.
    *
    *     RETURNS: 1 if all went well
    *              0 if not.
    */

   prog = new_list;

   return( 1 );
  }
/***************************************************************************/
MvclProgramList *   MvclGetParserProgramList( void )

  {
   /* MvclGetParserProgramList() -- This function will return the pointer
    *     that points to the current mvcl program.
    *
    *     RETURNS: A pointer to the current program.
    */

   return( prog );
  }
/***************************************************************************/
#ifdef MVCL_STAND_ALONE
int main(
   int   argc,
   char  **argv )

  {
   /* main() -- O/S transfer point.
    *      Check for any command line arguments. By default the shell will
    *      run in interactive mode ( accepting commands ) if a file name is
    *      present on the command line then that file will be executed as a
    *      mvcl program.
    *
    *      RETURNS: 0 always.
    */
   int     ret;
   int     script_ret;
   int     ch;
   int     source_mode = 0;
   char    *source_fname;
   extern int   opterr;
   extern int   optind;
   extern char  *optarg;
   
   /* process the command line arguments -- let getopt report the errors */
   while( ( ch = getopt( argc, argv, "df:" ) ) != EOF )
     {
      switch( ch )
        {
	 case 'd':
           yydebug = 1;
           break;

         case 'f':
           source_mode = 1;
           source_fname = optarg;
           break;

         case '?':
         default:
           fprintf( stderr, "Usage: mvclshell [-d] [-f <file>]\n" );
	   exit( 1 );
           break;
        }           
     }

   /* Create an instance of an mvcl program. */
   prog = CreateMvclProgramList();

   /* Init mvcl data structures. */
   MvclQueryVacuumSystem( "../VacConfig.M" );

   if( source_mode == 1 )
     {
      /* make an attempt to parse the file named on the command line */
      fprintf( stderr, "Running The Program %s...\n", source_fname );

      ret = MvclRun( source_fname, &script_ret );

      if( ret == -1 )
        fprintf( stderr, "Parser Failed, Program NOT Interpreted...\n" );
      else if( ret == -2 )
        fprintf( stderr, "Program Failed...\n" );
      else if( ret == -3 )
        fprintf( stderr, "Error Opening File <%s>...\n", source_fname );
      else
        fprintf( stderr, "Done...\n" );
     }
   else
     MvclShell();

   /* Clear up memory before quitting ( just to be tidy ). */
   DestroyMvclProgramList( prog );

   return( 0 );
  }
#endif
/***************************************************************************/
/* finis */











