# common.mak --
#
# This is the common part shared by the Jacl and TclBlend
# makefile.vc's
#
# Copyright (c) 1997 Sun Microsystems, Inc. All rights reserved.
#
# SCCS: @(#) common.mak 1.7 97/10/21 13:33:44

COMMON_CLASSES = \
	$(TCLJAVA)\tcl\lang\AmbiguousSignatureException.class \
	$(TCLJAVA)\tcl\lang\Command.class \
	$(TCLJAVA)\tcl\lang\CommandWithDispose.class \
	$(TCLJAVA)\tcl\lang\Extension.class \
	$(TCLJAVA)\tcl\lang\InternalRep.class \
	$(TCLJAVA)\tcl\lang\Invoke.class \
	$(TCLJAVA)\tcl\lang\JavaCallCmd.class \
	$(TCLJAVA)\tcl\lang\JavaFieldCmd.class \
	$(TCLJAVA)\tcl\lang\JavaInstanceofCmd.class \
	$(TCLJAVA)\tcl\lang\JavaInfoCmd.class \
	$(TCLJAVA)\tcl\lang\JavaLoadCmd.class \
	$(TCLJAVA)\tcl\lang\JavaNewCmd.class \
	$(TCLJAVA)\tcl\lang\JavaNullCmd.class \
	$(TCLJAVA)\tcl\lang\JavaPropCmd.class \
	$(TCLJAVA)\tcl\lang\ReflectException.class \
	$(TCLJAVA)\tcl\lang\TCL.class \
	$(TCLJAVA)\tcl\lang\TclBoolean.class \
	$(TCLJAVA)\tcl\lang\TclClassLoader.class \
	$(TCLJAVA)\tcl\lang\TclDouble.class \
	$(TCLJAVA)\tcl\lang\TclException.class \
	$(TCLJAVA)\tcl\lang\TclIndex.class \
	$(TCLJAVA)\tcl\lang\TclInteger.class \
	$(TCLJAVA)\tcl\lang\TclNumArgsException.class \
	$(TCLJAVA)\tcl\lang\TclObject.class \
	$(TCLJAVA)\tcl\lang\TclRuntimeError.class \
	$(TCLJAVA)\tcl\lang\TclString.class \
	$(TCLJAVA)\tcl\lang\VarTrace.class 

NATIVE_CLASSES = \
	$(TCLJAVA)\tcl\lang\CObject.class \
	$(TCLJAVA)\tcl\lang\Interp.class \
	$(TCLJAVA)\tcl\lang\ReflectObject.class \
	$(TCLJAVA)\tcl\lang\TclList.class \
	$(TCLJAVA)\tcl\lang\Util.class

JAVA_CLASSES = \
        $(TCLJAVA)\tcl\lang\AdaptorClassLoader.class \
        $(TCLJAVA)\tcl\lang\AdaptorGen.class \
	$(TCLJAVA)\tcl\lang\AfterCmd.class \
	$(TCLJAVA)\tcl\lang\AppendCmd.class \
	$(TCLJAVA)\tcl\lang\ArrayCmd.class \
        $(TCLJAVA)\tcl\lang\BackSlashResult.class \
        $(TCLJAVA)\tcl\lang\BeanEvent.class \
	$(TCLJAVA)\tcl\lang\BindCmd.class \
	$(TCLJAVA)\tcl\lang\BreakCmd.class \
	$(TCLJAVA)\tcl\lang\CallFrame.class \
	$(TCLJAVA)\tcl\lang\CaseCmd.class \
	$(TCLJAVA)\tcl\lang\CatchCmd.class \
	$(TCLJAVA)\tcl\lang\CdCmd.class \
        $(TCLJAVA)\tcl\lang\Channel.class \
	$(TCLJAVA)\tcl\lang\CloseCmd.class \
        $(TCLJAVA)\tcl\lang\CObject.class \
	$(TCLJAVA)\tcl\lang\ContinueCmd.class \
	$(TCLJAVA)\tcl\lang\ConcatCmd.class \
	$(TCLJAVA)\tcl\lang\Env.class \
	$(TCLJAVA)\tcl\lang\ConsoleEvent.class \
        $(TCLJAVA)\tcl\lang\DebugInfo.class \
	$(TCLJAVA)\tcl\lang\EofCmd.class \
	$(TCLJAVA)\tcl\lang\ErrorCmd.class \
	$(TCLJAVA)\tcl\lang\EvalCmd.class \
        $(TCLJAVA)\tcl\lang\EventAdaptor.class \
	$(TCLJAVA)\tcl\lang\ExecCmd.class \
	$(TCLJAVA)\tcl\lang\ExitCmd.class \
	$(TCLJAVA)\tcl\lang\ExprCmd.class \
        $(TCLJAVA)\tcl\lang\Expression.class \
        $(TCLJAVA)\tcl\lang\ExprValue.class \
	$(TCLJAVA)\tcl\lang\FblockedCmd.class \
	$(TCLJAVA)\tcl\lang\FconfigureCmd.class \
	$(TCLJAVA)\tcl\lang\FileChannel.class \
	$(TCLJAVA)\tcl\lang\FileCmd.class \
        $(TCLJAVA)\tcl\lang\FindElemResult.class \
	$(TCLJAVA)\tcl\lang\FlushCmd.class \
	$(TCLJAVA)\tcl\lang\ForCmd.class \
	$(TCLJAVA)\tcl\lang\ForeachCmd.class \
	$(TCLJAVA)\tcl\lang\FormatCmd.class \
	$(TCLJAVA)\tcl\lang\GetsCmd.class \
	$(TCLJAVA)\tcl\lang\GlobalCmd.class \
	$(TCLJAVA)\tcl\lang\GlobCmd.class \
	$(TCLJAVA)\tcl\lang\IfCmd.class \
	$(TCLJAVA)\tcl\lang\IncrCmd.class \
	$(TCLJAVA)\tcl\lang\InfoCmd.class \
	$(TCLJAVA)\tcl\lang\Interp.class \
	$(TCLJAVA)\tcl\lang\JoinCmd.class \
	$(TCLJAVA)\tcl\lang\LappendCmd.class \
	$(TCLJAVA)\tcl\lang\LindexCmd.class \
	$(TCLJAVA)\tcl\lang\LinsertCmd.class \
	$(TCLJAVA)\tcl\lang\ListCmd.class \
	$(TCLJAVA)\tcl\lang\LlengthCmd.class \
	$(TCLJAVA)\tcl\lang\LrangeCmd.class \
	$(TCLJAVA)\tcl\lang\LreplaceCmd.class \
	$(TCLJAVA)\tcl\lang\LsearchCmd.class \
	$(TCLJAVA)\tcl\lang\LsortCmd.class \
	$(TCLJAVA)\tcl\lang\NamespaceCmd.class \
	$(TCLJAVA)\tcl\lang\OpenCmd.class \
	$(TCLJAVA)\tcl\lang\PackageCmd.class \
        $(TCLJAVA)\tcl\lang\ParseResult.class \
        $(TCLJAVA)\tcl\lang\ParseResultVector.class \
        $(TCLJAVA)\tcl\lang\Procedure.class \
	$(TCLJAVA)\tcl\lang\ProcCmd.class \
	$(TCLJAVA)\tcl\lang\PutsCmd.class \
	$(TCLJAVA)\tcl\lang\PwdCmd.class \
        $(TCLJAVA)\tcl\lang\QSort.class \
	$(TCLJAVA)\tcl\lang\ReadCmd.class \
        $(TCLJAVA)\tcl\lang\ReflectObject.class \
        $(TCLJAVA)\tcl\lang\ReflectParamInfo.class \
	$(TCLJAVA)\tcl\lang\RegexpCmd.class \
	$(TCLJAVA)\tcl\lang\RegsubCmd.class \
	$(TCLJAVA)\tcl\lang\RenameCmd.class \
	$(TCLJAVA)\tcl\lang\ReturnCmd.class \
	$(TCLJAVA)\tcl\lang\ScanCmd.class \
        $(TCLJAVA)\tcl\lang\SearchId.class \
	$(TCLJAVA)\tcl\lang\SeekCmd.class \
	$(TCLJAVA)\tcl\lang\SetCmd.class \
	$(TCLJAVA)\tcl\lang\Shell.class \
	$(TCLJAVA)\tcl\lang\SocketCmd.class \
	$(TCLJAVA)\tcl\lang\SourceCmd.class \
	$(TCLJAVA)\tcl\lang\SplitCmd.class \
        $(TCLJAVA)\tcl\lang\StdChannel.class \
	$(TCLJAVA)\tcl\lang\StringCmd.class \
        $(TCLJAVA)\tcl\lang\StrtodResult.class \
        $(TCLJAVA)\tcl\lang\StrtoulResult.class \
	$(TCLJAVA)\tcl\lang\SubstCmd.class \
	$(TCLJAVA)\tcl\lang\SwitchCmd.class \
        $(TCLJAVA)\tcl\lang\TclEvent.class \
        $(TCLJAVA)\tcl\lang\TclIO.class \
        $(TCLJAVA)\tcl\lang\TclList.class \
        $(TCLJAVA)\tcl\lang\TclVarException.class \
	$(TCLJAVA)\tcl\lang\TellCmd.class \
	$(TCLJAVA)\tcl\lang\TimerEvent.class \
	$(TCLJAVA)\tcl\lang\TimeCmd.class \
	$(TCLJAVA)\tcl\lang\TimerEvent.class \
	$(TCLJAVA)\tcl\lang\TraceCmd.class \
        $(TCLJAVA)\tcl\lang\TraceRecord.class \
	$(TCLJAVA)\tcl\lang\UnsetCmd.class \
	$(TCLJAVA)\tcl\lang\UplevelCmd.class \
	$(TCLJAVA)\tcl\lang\UpvarCmd.class \
        $(TCLJAVA)\tcl\lang\Util.class \
        $(TCLJAVA)\tcl\lang\Var.class \
	$(TCLJAVA)\tcl\lang\VwaitCmd.class \
	$(TCLJAVA)\tcl\lang\WhileCmd.class \
	$(TCLJAVA)\tcl\lang\Word.class

DEMO_CLASSES = \
	$(DEMO_JAVA_DIR)\gluepkg\FileDialogApp.class \
	$(DEMO_JAVA_DIR)\gluepkg\FileDialogCmd.class \
	$(DEMO_JAVA_DIR)\gluepkg\GlueExtension.class \
	$(DEMO_JAVA_DIR)\gluepkg\JarCmd.class \
	$(DEMO_JAVA_DIR)\gluepkg\ListboxApp.class \
	$(DEMO_JAVA_DIR)\gluepkg\ListboxCmd.class \
	$(DEMO_JAVA_DIR)\pyramidpkg\AppletConsole.class \
	$(DEMO_JAVA_DIR)\pyramidpkg\ConsoleKeyListener.class \
	$(DEMO_JAVA_DIR)\pyramidpkg\ConsoleMouseListener.class \
	$(DEMO_JAVA_DIR)\pyramidpkg\Pyramid.class \
	$(DEMO_JAVA_DIR)\simplepkg\SayhelloCmd.class \
	$(DEMO_JAVA_DIR)\simplepkg\SimpleExtension.class \
	$(DEMO_JAVA_DIR)\watchpkg\StopWatchExtension.class \
	$(DEMO_JAVA_DIR)\watchpkg\StopWatchThread.class \
	$(DEMO_JAVA_DIR)\watchpkg\SwCmd.class

TEST_CLASSES = \
	$(TEST_CLASS_DIR)\ConvertTest.class \
	$(TEST_CLASS_DIR)\JavaTest.class \
	$(TEST_CLASS_DIR)\JavaTestSub.class \
	$(TEST_CLASS_DIR)\TestObjectCmd.class \
	$(TEST_CLASS_DIR)\invoke\ArrayTestClass.class \
	$(TEST_CLASS_DIR)\invoke\IntA.class \
	$(TEST_CLASS_DIR)\invoke\IntC.class \
	$(TEST_CLASS_DIR)\invoke\PublicTester.class \
	$(TEST_CLASS_DIR)\javainfo\InfoTestClass.class \
	$(TEST_CLASS_DIR)\javainfo\SuperTestClass.class \
	$(TEST_CLASS_DIR)\javaload\Test1Cmd.class \
	$(TEST_CLASS_DIR)\javaload\Test1Extension.class \
	$(TCLJAVA)\tcl\lang\GetInterpCmd.class \
	$(TCLJAVA)\tcl\lang\NonPublic.class \
	$(TCLJAVA)\tcl\lang\TestinvokeCmd.class

JAVALOAD_TEST_CLASSES = \
	$(TEST_CLASS_DIR)\javaload\Test2Cmd.class \
	$(TEST_CLASS_DIR)\javaload\Test2Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test3Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test4Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test5Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test6Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test7Extension.class \
	$(TEST_CLASS_DIR)\javaload\Test8Extension.class

JAVALOAD_TEST_JAR = \
	$(TEST_CLASS_DIR)\javaload\test9.jar

JACL_TEST_CLASSES = \
	$(TCLJAVA)\tcl\lang\JtestCmd.class \
	$(TCLJAVA)\tcl\lang\JavaTestExtension.class

NATIVE_TEST_CLASSES = \
	$(TCLJAVA)\tcl\lang\NativeTestExtension.class

TCLBLEND_CLASSES = $(NATIVE_CLASSES) $(COMMON_CLASSES)
JACL_CLASSES = $(JAVA_CLASSES) $(COMMON_CLASSES)

#----------------------------------------------------------------------
# Definitions for relative paths
#----------------------------------------------------------------------

COMMON_JAVA_DIR = ..\classes\common
DEMO_JAVA_DIR	= ..\demos
JAVA_JAVA_DIR	= ..\classes\java
NATIVE_JAVA_DIR	= ..\classes\native
TEST_JAVA_DIR	= ..\classes\tests
TEST_CLASS_DIR	= $(TCLJAVA)\tests
GENERIC_DIR	= ..\generic

#----------------------------------------------------------------------
# Implicit rules for compiling .class files
#----------------------------------------------------------------------

.SUFFIXES: .java .class

{$(COMMON_JAVA_DIR)\tcl\lang}.java{$(TCLJAVA)\tcl\lang}.class:
	echo $< >> depend.out

{$(TEST_JAVA_DIR)}.java{$(TEST_CLASS_DIR)}.class:
	echo $< >> depend.out

{$(TEST_JAVA_DIR)}.java{$(TEST_CLASS_DIR)\invoke}.class:
	echo $< >> depend.out

{$(TEST_JAVA_DIR)}.java{$(TEST_CLASS_DIR)\javainfo}.class:
	echo $< >> depend.out

{$(TEST_JAVA_DIR)\javaload}.java{$(TEST_CLASS_DIR)\javaload}.class:
	echo $< >> depend.out

{$(TEST_JAVA_DIR)}.java{$(TCLJAVA)\tcl\lang\}.class:
	echo $< >> depend.out

{$(DEMO_JAVA_DIR)\gluepkg}.java{$(DEMO_JAVA_DIR)\gluepkg}.class:
	echo $< >> depend.out

{$(DEMO_JAVA_DIR)\pyramidpkg}.java{$(DEMO_JAVA_DIR)\pyramidpkg}.class:
	echo $< >> depend.out

{$(DEMO_JAVA_DIR)\simplepkg}.java{$(DEMO_JAVA_DIR)\simplepkg}.class:
	echo $< >> depend.out

{$(DEMO_JAVA_DIR)\watchpkg}.java{$(DEMO_JAVA_DIR)\watchpkg}.class:
	echo $< >> depend.out

#----------------------------------------------------------------------
# Rules for building .class files
#----------------------------------------------------------------------

setup: BuildJava.class
	-@del depend.* 2> NUL
	-@mkdir $(TCLJAVA) 2> NUL

build:
	set CLASSPATH=$(TCLJAVA);.
	$(JAVA) BuildJava depend.out "$(JAVAC) -d $(TCLJAVA)"
	-@del depend.* 2> NUL

# Build the ZIP file for Jacl or TclBlend. We do a "clean" beforehand
# to make sure that the ZIP file doesn't include the test classes
# (which may cause security violations).

$(TCLJAVA).zip: clean $(TCLJAVA)
	cd $(TCLJAVA)
	jar c0f ..\$(TCLJAVA).zip tcl
	cd ..

#----------------------------------------------------------------------
# Rules for building test files
#----------------------------------------------------------------------

test.build: javatest.build javaload.build $(JAVALOAD_TEST_JAR)

javatest.build: setup javatest.depend
	set CLASSPATH=$(TCLJAVA);.
	$(JAVA) BuildJava depend.out "$(JAVAC) -d $(TCLJAVA)"
	-@del depend.* 2> NUL

javaload.build: setup javaload.depend
	set CLASSPATH=$(TCLJAVA);.
	$(JAVA) BuildJava depend.out "$(JAVAC) -d $(TEST_CLASS_DIR)\javaload"
	-@del depend.* 2> NUL

javaload.depend: $(JAVALOAD_TEST_CLASSES)

$(TEST_CLASS_DIR)\javaload\test9.jar: \
$(TEST_JAVA_DIR)\javaload\Test9Extension.java
	set CLASSPATH=$(TCLJAVA);$(TEST_CLASS_DIR)\javaload
	$(JAVAC) -d $(TEST_CLASS_DIR)\javaload \
		$(TEST_JAVA_DIR)\javaload\Test9Extension.java
	cd $(TEST_CLASS_DIR)\javaload
	jar c0f test9.jar Test9Extension.class
	del Test9Extension.class;
	cd ..\..\..\

#----------------------------------------------------------------------
# Building the demo classes.
#----------------------------------------------------------------------

demo: $(TCLJAVA) setup demo.depend demo.build

demo.depend: $(DEMO_CLASSES)

demo.build:
	set CLASSPATH=..\win\$(TCLJAVA);.
	$(JAVA) BuildJava depend.out "$(JAVAC)"
	-@del depend.* 2> NUL

#----------------------------------------------------------------------
# Misc stuff.
#----------------------------------------------------------------------

clean::
	-del $(TCLJAVA).zip
	-del BuildJava.class
	-rd /q /s $(TCLJAVA)

BuildJava.class: BuildJava.java
	$(JAVAC) BuildJava.java

